<template>
  <div v-if="extension_error" class="alert alert-danger" role="alert">
    <h4 class="alert-heading">{{ $t('extension.error') }}</h4>
    <p>{{  $t('extension.error_description') }}</p>
    <hr>
    <p class="mb-0">{{ error }}</p>
  </div>
  <div v-else class="home">
    <i18n-t keypath="home.intro" tag="p" scope="global">
      <template #fetchdoi>
        <fetch-doi class="link">{{ $t('home.fetchdoi_button') }}</fetch-doi>
      </template>
      <template #intro_second>
        <br/>{{ $t('home.intro_second') }}
      </template>
    </i18n-t>
    <div v-if="is_extension" class="alert alert-secondary" role="alert" v-html="$t('extension.additional_text')"></div>

    <search-form class="mt-5" />

    <search-results class="mt-3" />
    <div v-if="is_extension" class="mt-3 alert alert-secondary d-flex flex-row" role="alert">
      <div class="me-auto">
        <a v-if="$t('extension.support_url') !== 'extension.support_url'" :href="$t('extension.support_url')" target="_blank" rel="noopener noreferrer">{{ $t('extension.support_linktext') }}</a><br />
        {{ $t('extension.contact_linktext') }} <a :href="'mailto:' + contact_mail">{{ contact_mail }}</a>
      </div>
      <img
        v-if="institution_logo !== null"
        loading="lazy"
        :src="institution_logo"
        alt="Logo of instiution providing the extension"
        id="extension-img" />
    </div>
  </div>
</template>

<script>
// @ is an alias to /src
import SearchForm from '@/components/SearchForm.vue'
import SearchResults from '@/components/SearchResults.vue'
import FetchDoi from '@/components/FetchDoi.vue'
import RouterMetaMixin from '@/router/RouterMetaMixin.js'
import helper from '../helper'
import { mapState } from 'vuex'

export default {
  name: 'Home',
  title: 'home.title',
  mixins: [RouterMetaMixin, helper],
  components: {
    SearchForm,
    SearchResults,
    FetchDoi
  },
  created () {
    if (history.state.userData !== undefined) {
      // restore state from history
      this.$store.replaceState(history.state.userData)
      if (this.is_extension) {
        this.set_extension_in_translation(this.translations, this.$i18n.messages)
      }
    }
    window.addEventListener('beforeunload', this.saveState)

    this.$store.dispatch('fetchExtension', { extensionId: this.$route.query.extensionId, translation: this.$i18n.messages })
  },
  beforeUnmount () {
    window.removeEventListener('beforeunload', this.saveState)
  },
  beforeRouteLeave (to, from, next) {
    this.saveState()
    next()
  },
  methods: {
    saveState () {
      // save the store's state in the history to support back navigation
      // TODO: https://github.com/vuejs/rfcs/discussions/400 might allow
      //       to use vue router instead of fiddling with the history directly
      // TODO: use structuredClone once supported (nodejs 17)
      const clonedState = JSON.parse(JSON.stringify(this.$store.state))
      history.pushState({ ...history.state, userData: clonedState }, '')
    }
  },
  computed: mapState({
    institution_logo: state => state.extension.institution_logo,
    is_extension: state => state.extension.is_set,
    translations: state => state.extension.translations,
    contact_mail: state => state.extension.contact_mail,
    extension_error: state => state.state === 'ERROR_EXTENSION',
    error: state => state.error
  })
}
</script>
<style scoped>
#extension-img {
  max-height: 70px;
  max-width: 140px;
  height: 100%;
}
</style>
